/* Datei: hashtab.h */
/* Funktionen zur Verwaltung von Hashtabellen mit linearer        */
/* Sondierung (ohne Schluesselabhaengigkeit als Konfliktstrategie)*/
/* Elemente mit gleichem Namen seien in diesem Beispiel verboten, */
/* sind aber bei Hashtabellen prinzipell zulaessig. In diesem     */
/* Beispiel duerfen nur Namen != "0" und != "1" vorkommen , da    */
/* diese Werte fuer die Markierung von freien bzw. geloeschten    */
/* Zellen genutzt werden                                          */

#define GRENZE    7        /* Anzahl der Tabellenplaetze          */
#define FUELLWERT 7        /* Anzahl der einzugebenden Elemente   */
#define FREI      "0"      /* Festlegung eines FREI-Zeichens      */
#define GELOESCHT "1"      /* Festlegung eines GELOESCHT-Zeichens */

typedef struct messwert 
{
   char name[40];                        /* Name des Messgeraetes */
   double wert;                          /* Messwert des Geraetes */
} MESSWERT;

MESSWERT tabelle [GRENZE];               /* Anlegen der Tabelle   */

int hash (char *);          
int rehash (int);        
int einfuegen (MESSWERT, MESSWERT *); 
int loeschen (char *, MESSWERT *);
int suche_schluessel (char *, MESSWERT *);
static void init_tabelle (MESSWERT *);
static void fuelle_tabelle (MESSWERT *);
void ausgeben_tabelle (MESSWERT *);
void eingabe_Puffer_loeschen (void);

