/* Datei: mutex.c */
#include <stdio.h>
#include <threads.h>
#include <stdbool.h>

/* globale Variabl fuer Mutex */
mtx_t mutex;

/* gemeinsam genutzte Ressource */
int i[3] = {0, 0, 0};

/* Terminierungsvariable (vereinfacht, nicht synchronisiert)*/
int terminate = false;

/* Thread 1 (Schreiber) */
int writerThread (void * arg)
{
   (void) arg; /* wird nicht verwendet */
   while (true)
   { 
      mtx_lock (&mutex);
      printf ("schreibe Daten\n");

      /* schreibe gemeinsam genutzte Ressource */
      i[0]++;
      i[1]++;
      i[2]++;
      mtx_unlock (&mutex);

      if (terminate == true) 
      {
         break;
      }
      thrd_yield();
   }
   return thrd_success;
}

/* Thread 2 (Leser) */
int readerThread (void * arg)
{
   (void) arg; /* wird nicht verwendet */
   while (true)
   {
      mtx_lock (&mutex);

      /* lese gemeinsam genutzte Ressource */
      printf ("lese Daten: %i, %i, %i\n", i[0], i[1], i[2]);

      mtx_unlock (&mutex);

      if (terminate == true)
      {
         break;
      }
      thrd_yield();
   }
   return thrd_success;
}

int main (void) 
{
   /* Variable zum Speichern der Thread ID */
   thrd_t reader, writer;

   /* Initialisierung der Variablen und Erzeugung der Threads*/
   mtx_init (&mutex, mtx_plain);
   thrd_create (&reader, readerThread, NULL);
   thrd_create (&writer, writerThread, NULL);

   for (int i = 0; i < 1e8; i++) 
   {
      /* eine Weile warten... */
   }

   /* Beenden der Threads und Freigeben der Variablen*/
   terminate = true;
   thrd_join (reader, NULL);
   thrd_join (writer, NULL);
   mtx_destroy (&mutex);
}